.hey-functions: &hey-functions |

  function load_testing() {
    touch -a metrics.txt
    hey -z=${DURATION} \
    -q ${REQUESTS_PER_SECONDS} \
    -c ${ACTIVE_USERS} \
    -m GET ${URL} \
    > load.testing.report.txt     
  }

  function summary() {
    RESULTS=$(REPORT="$(cat load.testing.report.txt)" node --eval '

      let res = process.env.REPORT.split("\n").map(item => item.trim()).filter(item => item !== "")

      let total = res.find(item => item.startsWith("Total:"))
      let slowest = res.find(item => item.startsWith("Slowest:"))
      let fastest = res.find(item => item.startsWith("Fastest:"))
      let average = res.find(item => item.startsWith("Average:"))
      let requests = res.find(item => item.startsWith("Requests/sec:"))

      //let total_data = res.find(item => item.startsWith("Total data:"))
      //let size_request = res.find(item => item.startsWith("Size/request:"))

      let histogram = res.filter(item => item.includes("|")).join("\n")
      
      let content = [
          `#### Load testing report`
        , `**Summary:**`
        , `- ${total}`
        , `- ${slowest}`
        , `- ${fastest}`
        , `- ${average}`
        , `- ${requests}`
        , ``
        , `**Response time histogram:**`
         , "```"
        , `${histogram}`
        , "```"       
      ] 
      
      console.log(content.join("\n"))
    ')

    GITLAB_API_URL="${GITLAB_URL}/api/v4/projects"
    PROJECT_ID=$CI_MERGE_REQUEST_PROJECT_ID
    MR_IID=$CI_MERGE_REQUEST_IID
    curl -d "body=$RESULTS" --request POST --header "PRIVATE-TOKEN: $GITLAB_BOT_TOKEN" \
    $GITLAB_API_URL/$PROJECT_ID/merge_requests/$MR_IID/notes  
  }

  function metrics() {
    REPORT="$(cat load.testing.report.txt)" node --eval '

      let res = process.env.REPORT.split("\n").map(item => item.trim()).filter(item => item !== "")

      let total = res.find(item => item.startsWith("Total:"))
      let slowest = res.find(item => item.startsWith("Slowest:"))
      let fastest = res.find(item => item.startsWith("Fastest:"))
      let average = res.find(item => item.startsWith("Average:"))

      let getMetric = (text) => {
        metric=text.split(":")
        name=metric[0]
        value=metric[1].replace("secs","").trim()
        return `${name} ${value}`
      }
      metrics = [
        getMetric("🧮"+total), getMetric("🐌"+slowest), getMetric("🐰"+fastest), getMetric("📊"+average)
      ]

      require("fs").writeFileSync("metrics.txt", metrics.join("\n"), "utf8")

      //let htmlReport = metrics.map(item => `<h3>${item}</h3>`)
      //require("fs").writeFileSync("metrics.html", metrics.join(""), "utf8")

    '
    echo "🖐️ Metrics report:"
    cat ./metrics.txt
  }

# usage example:
# 
# .💣http-load-generator:
#   stage: 🧨stress
#   extends: .stress:load:testing
#   environment:
#     on_stop: 😢stop-preview-deploy
#   variables:
#     ACTIVE_USERS: 100
#     REQUESTS_PER_SECONDS: 50
#     DURATION: "30s"

.stress:load:testing: 
  image: registry.gitlab.com/tanuki-workshops/earth/images/ci-tools/ci-js:latest
  only: 
    #- merge_requests
    - branches
    #- master in this case I should create a report in a issue or somewhere else
  environment:
    name: preview/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
  before_script:
    - *hey-functions
  artifacts:
    paths:
    - load.testing.report.txt
    #- metrics.html
    expire_in: 1 week
    reports:
      metrics: metrics.txt
  script: |
    export URL=http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
    load_testing
    summary # post a note to the MR
  
  
.stress:preview:metrics: 
  image: registry.gitlab.com/tanuki-workshops/earth/images/ci-tools/ci-js:latest
  only: 
    #- merge_requests
    - branches
  environment:
    name: preview/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
  before_script:
    - *hey-functions
  artifacts:
    paths:
    - load.testing.report.txt
    #- metrics.html
    expire_in: 1 week
    reports:
      metrics: metrics.txt
  script: |
    export URL=http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
    load_testing
    metrics

.stress:production:metrics: 
  image: registry.gitlab.com/tanuki-workshops/earth/images/ci-tools/ci-js:latest
  only: 
    - master
  environment:
    name: production/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
  before_script:
    - *hey-functions
  artifacts:
    paths:
    - load.testing.report.txt
    #- metrics.html
    expire_in: 1 week
    reports:
      metrics: metrics.txt
  script: |
    export URL=http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
    load_testing
    metrics
